<?php

App::uses('EvFacebookAppModel', 'EvFacebook.Model');
App::uses('CakeTime', 'Utility');

class FacebookStream extends EvFacebookAppModel {

	public function getStream($limit=10) {
		
		$lastInsert = $this->field('created', array(), 'id DESC');
		$check = CakeTime::wasWithinLast('5 hours', $lastInsert);

		$facebookPageId = Configure::read('Facebook.page_id');

		// If we haven't updated the cached stream for 5 hours get the latest posts
		if ($check === false) {

			if (!empty($lastInsert)) {
				$lastFbPostDate = $this->field('post_date', array(), 'post_date DESC');
				$dateFql = ' AND created_time > ' . strtotime($lastFbPostDate);
			} else {
				$dateFql = '';
			}

			$fql = 'SELECT permalink, created_time, attachment, message FROM stream';
			$fql .= ' WHERE source_id=' . $facebookPageId . ' AND actor_id=' . $facebookPageId;
			$fql .= ' AND message <> \'\'';
			$fql .= $dateFql;
			$fql .= ' LIMIT ' . $limit;

			$response = $this->Facebook->api(array(
				'method' => 'fql.query',
				'query' => $fql
			));

			$data = array();

			foreach ($response as $row) {

				$data[] = array(
					'post' => serialize($row),
					'post_date' => CakeTime::format('Y-m-d H:i:s', $row['created_time'])
				);

			}

			$this->saveMany($data);

		}

		$data = $this->find('all', array(
			'fields' => array(
				$this->escapeField(),
				$this->escapeField('post'),
				$this->escapeField('post_date')
			),
			'order' => array(
				$this->escapeField('post_date') => 'DESC'
			),
			'limit' => $limit
		));

		return $data;

	}


	public function afterFind($results, $primary = false) {

		$results = parent::afterFind($results, $primary);

		foreach ($results as &$row) {
			if (isset($row[$this->alias]['post'])) {
				$row[$this->alias]['post'] = unserialize($row[$this->alias]['post']);
			}
		}

		return $results;

	}

}